// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "GameFramework/Character.h"
#include "PublicCharacter.generated.h"

UCLASS()
class SIMPLEGAME_API APublicCharacter : public ACharacter
{
	GENERATED_BODY()

public:
	// Sets default values for this character's properties
	APublicCharacter();
	
	USkeletalMeshComponent* GetSpecificPawnMesh() const;

	FName GetWeaponAttachPoint() const;

	void EquipWeapon(class ASimpleWeapon* Weapon);


protected:
	UPROPERTY(EditDefaultsOnly, Category = Inventory)
	FName WeaponAttachPoint;

	TArray<class ASimpleWeapon*> Inventory;

	class ASimpleWeapon* CurrentWeapon;

	void AddWeapon(class ASimpleWeapon* Weapon);

	void SetCurrentWeapon(class ASimpleWeapon* NewWeapon, class ASimpleWeapon* LastWeapon);

	UPROPERTY(EditDefaultsOnly, Category = Inventory)
		TArray<TSubclassOf<class ASimpleWeapon>> DefaultInventoryClasses;

	void SpawnDefaultInventory();
};
