// Fill out your copyright notice in the Description page of Project Settings.

#include "SimpleGame.h"
#include "SimpleWeapon.h"


// Sets default values
ASimpleWeapon::ASimpleWeapon(const class FObjectInitializer& ObjectInitializer)
	:Super(ObjectInitializer)
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	WeaponMesh = ObjectInitializer.CreateDefaultSubobject<USkeletalMeshComponent>(this, TEXT("WeaponMesh"));
	WeaponMesh->CastShadow = true;
	WeaponMesh->SetCollisionEnabled(ECollisionEnabled::NoCollision);
	RootComponent = WeaponMesh;

}

void ASimpleWeapon::SetOwningPawn(APublicCharacter* NewOwner)
{
	if (MyPawn != NewOwner)
	{
		MyPawn = NewOwner;
	}
}

void ASimpleWeapon::AttachMeshToPawn()
{
	if (MyPawn)
	{
		USkeletalMeshComponent* PawnMesh = MyPawn->GetSpecificPawnMesh();
		FName AttachPoint = MyPawn->GetWeaponAttachPoint();
		WeaponMesh->AttachTo(PawnMesh, AttachPoint);
	}
}

void ASimpleWeapon::OnEquip(const ASimpleWeapon* LastWeapon)
{
	AttachMeshToPawn();
}

void ASimpleWeapon::OnUnEquip()
{
	WeaponMesh->DetachFromParent();
}


